package com.zcloud.controller.invoice;

import com.zcloud.controller.base.BaseController;
import com.zcloud.entity.Page;
import com.zcloud.entity.PageData;
import com.zcloud.logs.LogAnno;
import com.zcloud.service.invoice.BillingManageService;
import com.zcloud.util.DateUtil;
import com.zcloud.util.Jurisdiction;
import com.zcloud.util.ObjectExcelView;
import com.zcloud.util.Tools;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import java.util.*;

/**
 * 说明：开票管理
 * 作者：luoxiaobao
 * 时间：2021-03-23
 * 官网：www.zcloudchina.com
 */
@Controller
@RequestMapping("/billingmanage")
public class BillingManageController extends BaseController {

	@Autowired
	private BillingManageService billingmanageService;

//	@Autowired
//	private CorpInfoService corpinfoService;
	/**新增
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/add")
	// @RequiresPermissions("billingmanage:add")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "发票管理",instructionsOperate = "开票管理",instructionsType = "新增")
	public Object add() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("BILLINGMANAGE_ID", this.get32UUID());	//主键
		pd.put("PAYMENTTIME", DateUtil.date2Str(new Date()));	//支付时间
		pd.put("MONEY", "");	//金额
		pd.put("BILLINGSTATUS", "");	//开票状态
		pd.put("INVOICEMANAGER_ID", "");	//发票ID
		billingmanageService.save(pd);
		map.put("result", errInfo);
		return map;
	}

	/**删除
	 * @param out
	 * @throws Exception
	 */
	@RequestMapping(value="/delete")
	// @RequiresPermissions("billingmanage:del")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "发票管理",instructionsOperate = "开票管理",instructionsType = "删除")
	public Object delete() throws Exception{
		Map<String,String> map = new HashMap<String,String>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		billingmanageService.delete(pd);
		map.put("result", errInfo);				//返回结果
		return map;
	}

	/**修改
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/edit")
	// @RequiresPermissions("billingmanage:edit")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "发票管理",instructionsOperate = "开票管理",instructionsType = "修改")
	public Object edit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		billingmanageService.edit(pd);
		map.put("result", errInfo);
		return map;
	}
	/**修改
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/editkp")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "发票管理",instructionsOperate = "开票管理",instructionsType = "修改")
	public Object editkp() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		billingmanageService.editkp(pd);
		map.put("result", errInfo);
		return map;
	}

	/**列表
	 * @param page
	 * @throws Exception
	 */
	@RequestMapping(value="/list")
	// @RequiresPermissions("billingmanage:list")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "发票管理",instructionsOperate = "开票管理",instructionsType = "列表")
	public Object list(Page page) throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String KEYWORDS = pd.getString("KEYWORDS");						//关键词检索条件
		if(Tools.notEmpty(KEYWORDS))pd.put("KEYWORDS", KEYWORDS.trim());
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());
		page.setPd(pd);
		List<PageData>	varList = billingmanageService.list(page);	//列出BillingManage列表
//		PageData cpd = new PageData();
//		cpd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());
//		cpd=corpinfoService.findById(cpd);
//		if(cpd!=null) {
//			map.put("cpd", cpd);
//		}

		map.put("varList", varList);
		map.put("page", page);
		map.put("result", errInfo);
		return map;
	}

	 /**去修改页面获取数据
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/goEdit")
	// @RequiresPermissions("billingmanage:edit")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "发票管理",instructionsOperate = "开票管理",instructionsType = "去修改页面获取数据")
	public Object goEdit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd = billingmanageService.findById(pd);	//根据ID读取
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	 /**批量删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/deleteAll")
	// @RequiresPermissions("billingmanage:del")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "发票管理",instructionsOperate = "开票管理",instructionsType = "批量删除")
	public Object deleteAll() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String DATA_IDS = pd.getString("DATA_IDS");
		if(Tools.notEmpty(DATA_IDS)){
			String ArrayDATA_IDS[] = DATA_IDS.split(",");
			billingmanageService.deleteAll(ArrayDATA_IDS);
			errInfo = "success";
		}else{
			errInfo = "error";
		}
		map.put("result", errInfo);				//返回结果
		return map;
	}

	 /**导出到excel
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/excel")
	// @RequiresPermissions("toExcel")
	@LogAnno(menuType= "综合管理",menuServer= "发票管理",instructionsOperate = "开票管理",instructionsType = "导出到excel")
	public ModelAndView exportExcel() throws Exception{
		ModelAndView mv = new ModelAndView();
		PageData pd = new PageData();
		pd = this.getPageData();
		Map<String,Object> dataMap = new HashMap<String,Object>();
		List<String> titles = new ArrayList<String>();
		titles.add("支付时间");	//1
		titles.add("金额");	//2
		titles.add("开票状态");	//3
		titles.add("发票ID");	//4
		dataMap.put("titles", titles);
		List<PageData> varOList = billingmanageService.listAll(pd);
		List<PageData> varList = new ArrayList<PageData>();
		for(int i=0;i<varOList.size();i++){
			PageData vpd = new PageData();
			vpd.put("var1", varOList.get(i).getString("PAYMENTTIME"));	    //1
			vpd.put("var2", varOList.get(i).getString("MONEY"));	    //2
			vpd.put("var3", varOList.get(i).getString("BILLINGSTATUS"));	    //3
			vpd.put("var4", varOList.get(i).getString("INVOICEMANAGER_ID"));	    //4
			varList.add(vpd);
		}
		dataMap.put("varList", varList);
		ObjectExcelView erv = new ObjectExcelView();
		mv = new ModelAndView(erv,dataMap);
		return mv;
	}

}
